Git 2.10.2
[git/git.git] / git-sh-setup.sh
CommitLineData
11d62145
JN
1# This shell scriplet is meant to be included by other shell scripts
2# to set up some variables pointing at the normal git directories and
3# a few helper shell functions.
b33e9666 4
d323c6b6
VA
5# Source git-sh-i18n for gettext support.
6. git-sh-i18n
7
365527ad 8# Having this variable in your environment would break scripts because
e598c517 9# you would cause "cd" to be taken to unexpected places. If you
365527ad
JH
10# like CDPATH, define it for your interactive shell sessions without
11# exporting it.
785063e0 12# But we protect ourselves from such a user mistake nevertheless.
365527ad
JH
13unset CDPATH
14
393050c3
JH
15# Similarly for IFS, but some shells (e.g. FreeBSD 7.2) are buggy and
16# do not equate an unset IFS with IFS with the default, so here is
17# an explicit SP HT LF.
18IFS='
19'
785063e0 20
61dbb3c4
JH
21git_broken_path_fix () {
22 case ":$PATH:" in
23 *:$1:*) : ok ;;
24 *)
25 PATH=$(
26 SANE_TOOL_PATH="$1"
27 IFS=: path= sep=
28 set x $PATH
29 shift
30 for elem
31 do
32 case "$SANE_TOOL_PATH:$elem" in
33 (?*:/bin | ?*:/usr/bin)
34 path="$path$sep$SANE_TOOL_PATH"
35 sep=:
36 SANE_TOOL_PATH=
37 esac
38 path="$path$sep$elem"
39 sep=:
40 done
41 echo "$path"
42 )
43 ;;
44 esac
45}
46
47# @@BROKEN_PATH_FIX@@
0e0aea5a 48
adb231cf
FG
49die () {
50 die_with_status 1 "$@"
51}
52
53die_with_status () {
54 status=$1
55 shift
89b0230a 56 printf >&2 '%s\n' "$*"
adb231cf 57 exit "$status"
b33e9666
LT
58}
59
e064c170
SB
60GIT_QUIET=
61
62say () {
63 if test -z "$GIT_QUIET"
64 then
65 printf '%s\n' "$*"
66 fi
67}
68
bac199b7
PH
69if test -n "$OPTIONS_SPEC"; then
70 usage() {
5d292756
JH
71 "$0" -h
72 exit 1
bac199b7
PH
73 }
74
e817e3e8
PH
75 parseopt_extra=
76 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
77 parseopt_extra="--keep-dashdash"
51ba8ce3
NV
78 [ -n "$OPTIONS_STUCKLONG" ] &&
79 parseopt_extra="$parseopt_extra --stuck-long"
e817e3e8
PH
80
81 eval "$(
cbea86fd 82 echo "$OPTIONS_SPEC" |
e817e3e8
PH
83 git rev-parse --parseopt $parseopt_extra -- "$@" ||
84 echo exit $?
85 )"
bac199b7 86else
7d665f35 87 dashless=$(basename -- "$0" | sed -e 's/-/ /')
bac199b7 88 usage() {
d323c6b6 89 die "$(eval_gettext "usage: \$dashless \$USAGE")"
bac199b7
PH
90 }
91
92 if [ -z "$LONG_USAGE" ]
93 then
d323c6b6 94 LONG_USAGE="$(eval_gettext "usage: \$dashless \$USAGE")"
bac199b7 95 else
d323c6b6 96 LONG_USAGE="$(eval_gettext "usage: \$dashless \$USAGE
bac199b7 97
d323c6b6 98$LONG_USAGE")"
bac199b7
PH
99 fi
100
101 case "$1" in
87182b17 102 -h)
bac199b7
PH
103 echo "$LONG_USAGE"
104 exit
105 esac
106fi
d025524d 107
c3e2d189
JH
108# Set the name of the end-user facing command in the reflog when the
109# script may update refs. When GIT_REFLOG_ACTION is already set, this
110# will not overwrite it, so that a scripted Porcelain (e.g. "git
111# rebase") can set it to its own name (e.g. "rebase") and then call
112# another scripted Porcelain (e.g. "git am") and a call to this
113# function in the latter will keep the name of the end-user facing
114# program (e.g. "rebase") in GIT_REFLOG_ACTION, ensuring whatever it
115# does will be record as actions done as part of the end-user facing
116# operation (e.g. "rebase").
117#
118# NOTE NOTE NOTE: consequently, after assigning a specific message to
119# GIT_REFLOG_ACTION when calling a "git" command to record a custom
120# reflog message, do not leave that custom value in GIT_REFLOG_ACTION,
121# after you are done. Other callers of "git" commands that rely on
122# writing the default "program name" in reflog expect the variable to
123# contain the value set by this function.
124#
125# To use a custom reflog message, do either one of these three:
126#
127# (a) use a single-shot export form:
128# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" \
129# git command-that-updates-a-ref
130#
131# (b) save the original away and restore:
132# SAVED_ACTION=$GIT_REFLOG_ACTION
133# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
134# git command-that-updates-a-ref
135# GIT_REFLOG_ACITON=$SAVED_ACTION
136#
137# (c) assign the variable in a subshell:
138# (
139# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
140# git command-that-updates-a-ref
141# )
f9474132
SP
142set_reflog_action() {
143 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
144 then
145 GIT_REFLOG_ACTION="$*"
146 export GIT_REFLOG_ACTION
147 fi
148}
149
ef0c2abf 150git_editor() {
b4479f07
JN
151 if test -z "${GIT_EDITOR:+set}"
152 then
153 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
154 fi
155
156 eval "$GIT_EDITOR" '"$@"'
ef0c2abf
AR
157}
158
f6dff119
JN
159git_pager() {
160 if test -t 1
161 then
162 GIT_PAGER=$(git var GIT_PAGER)
163 else
164 GIT_PAGER=cat
165 fi
995bc22d
EW
166 for vardef in @@PAGER_ENV@@
167 do
168 var=${vardef%%=*}
169 eval ": \"\${$vardef}\" && export $var"
170 done
f6dff119
JN
171
172 eval "$GIT_PAGER" '"$@"'
173}
174
e1622bfc 175sane_grep () {
71b40103 176 GREP_OPTIONS= LC_ALL=C grep @@SANE_TEXT_GREP@@ "$@"
e1622bfc
JH
177}
178
179sane_egrep () {
71b40103 180 GREP_OPTIONS= LC_ALL=C egrep @@SANE_TEXT_GREP@@ "$@"
e1622bfc
JH
181}
182
4b441f47 183is_bare_repository () {
5be60078 184 git rev-parse --is-bare-repository
4b441f47
JH
185}
186
9fde9401 187cd_to_toplevel () {
91dc602d
SD
188 cdup=$(git rev-parse --show-toplevel) &&
189 cd "$cdup" || {
d323c6b6 190 gettextln "Cannot chdir to \$cdup, the toplevel of the working tree" >&2
91dc602d
SD
191 exit 1
192 }
9fde9401
JH
193}
194
e2eb5273
JH
195require_work_tree_exists () {
196 if test "z$(git rev-parse --is-bare-repository)" != zfalse
197 then
d323c6b6
VA
198 program_name=$0
199 die "$(gettext "fatal: \$program_name cannot be used without a working tree.")"
e2eb5273
JH
200 fi
201}
202
7eff28a9 203require_work_tree () {
d323c6b6
VA
204 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true || {
205 program_name=$0
206 die "$(gettext "fatal: \$program_name cannot be used without a working tree.")"
207 }
7eff28a9
SP
208}
209
92c62a3f
RR
210require_clean_work_tree () {
211 git rev-parse --verify HEAD >/dev/null || exit 1
212 git update-index -q --ignore-submodules --refresh
213 err=0
214
215 if ! git diff-files --quiet --ignore-submodules
216 then
d323c6b6
VA
217 action=$1
218 case "$action" in
219 rebase)
220 gettextln "Cannot rebase: You have unstaged changes." >&2
221 ;;
222 "rewrite branches")
223 gettextln "Cannot rewrite branches: You have unstaged changes." >&2
224 ;;
225 "pull with rebase")
226 gettextln "Cannot pull with rebase: You have unstaged changes." >&2
227 ;;
228 *)
229 eval_gettextln "Cannot \$action: You have unstaged changes." >&2
230 ;;
231 esac
92c62a3f
RR
232 err=1
233 fi
234
235 if ! git diff-index --cached --quiet --ignore-submodules HEAD --
236 then
d323c6b6 237 if test $err = 0
92c62a3f 238 then
d323c6b6
VA
239 action=$1
240 case "$action" in
241 rebase)
242 gettextln "Cannot rebase: Your index contains uncommitted changes." >&2
243 ;;
244 "pull with rebase")
245 gettextln "Cannot pull with rebase: Your index contains uncommitted changes." >&2
246 ;;
247 *)
248 eval_gettextln "Cannot \$action: Your index contains uncommitted changes." >&2
249 ;;
250 esac
92c62a3f 251 else
d323c6b6 252 gettextln "Additionally, your index contains uncommitted changes." >&2
92c62a3f
RR
253 fi
254 err=1
255 fi
256
d323c6b6 257 if test $err = 1
92c62a3f 258 then
d323c6b6 259 test -n "$2" && echo "$2" >&2
92c62a3f
RR
260 exit 1
261 fi
262}
263
ce80ca56
JK
264# Generate a sed script to parse identities from a commit.
265#
266# Reads the commit from stdin, which should be in raw format (e.g., from
267# cat-file or "--pretty=raw").
268#
269# The first argument specifies the ident line to parse (e.g., "author"), and
270# the second specifies the environment variable to put it in (e.g., "AUTHOR"
271# for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and
272# committer.
273pick_ident_script () {
274 while test $# -gt 0
275 do
276 lid=$1; shift
277 uid=$1; shift
278 printf '%s' "
279 /^$lid /{
280 s/'/'\\\\''/g
281 h
282 s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'"
283 s/.*/GIT_${uid}_NAME='&'/p
284
285 g
286 s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'"
287 s/.*/GIT_${uid}_EMAIL='&'/p
288
289 g
290 s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'"
291 s/.*/GIT_${uid}_DATE='&'/p
292 }
293 "
294 done
295 echo '/^$/q'
296}
297
298# Create a pick-script as above and feed it to sed. Stdout is suitable for
299# feeding to eval.
300parse_ident_from_commit () {
301 LANG=C LC_ALL=C sed -ne "$(pick_ident_script "$@")"
302}
303
304# Parse the author from a commit given as an argument. Stdout is suitable for
305# feeding to eval to set the usual GIT_* ident variables.
0cae2346 306get_author_ident_from_commit () {
0cae2346 307 encoding=$(git config i18n.commitencoding || echo UTF-8)
077b725f 308 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
ce80ca56 309 parse_ident_from_commit author AUTHOR
0cae2346
JS
310}
311
7d750f0e
GB
312# Clear repo-local GIT_* environment variables. Useful when switching to
313# another repository (e.g. when entering a submodule). See also the env
314# list in git_connect()
315clear_local_git_env() {
316 unset $(git rev-parse --local-env-vars)
317}
318
4549162e
KB
319# Generate a virtual base file for a two-file merge. Uses git apply to
320# remove lines from $1 that are not in $2, leaving only common lines.
321create_virtual_base() {
322 sz0=$(wc -c <"$1")
323 @@DIFF@@ -u -La/"$1" -Lb/"$1" "$1" "$2" | git apply --no-add
324 sz1=$(wc -c <"$1")
325
326 # If we do not have enough common material, it is not
327 # worth trying two-file merge using common subsections.
328 expr $sz0 \< $sz1 \* 2 >/dev/null || : >"$1"
329}
330
87bddba9 331
10587ce6 332# Platform specific tweaks to work around some commands
87bddba9
JS
333case $(uname -s) in
334*MINGW*)
335 # Windows has its own (incompatible) sort and find
336 sort () {
337 /usr/bin/sort "$@"
338 }
339 find () {
340 /usr/bin/find "$@"
341 }
be39048a
RJ
342 # git sees Windows-style pwd
343 pwd () {
344 builtin pwd -W
345 }
5e9677cb
PT
346 is_absolute_path () {
347 case "$1" in
348 [/\\]* | [A-Za-z]:*)
349 return 0 ;;
350 esac
351 return 1
352 }
87bddba9 353 ;;
5e9677cb
PT
354*)
355 is_absolute_path () {
356 case "$1" in
357 /*)
358 return 0 ;;
359 esac
360 return 1
361 }
87bddba9 362esac
10587ce6
JH
363
364# Make sure we are in a valid repository of a vintage we understand,
365# if we require to be in a git repository.
1c7e2d23 366git_dir_init () {
10587ce6
JH
367 GIT_DIR=$(git rev-parse --git-dir) || exit
368 if [ -z "$SUBDIRECTORY_OK" ]
369 then
370 test -z "$(git rev-parse --show-cdup)" || {
371 exit=$?
d323c6b6 372 gettextln "You need to run this command from the toplevel of the working tree." >&2
10587ce6
JH
373 exit $exit
374 }
375 fi
376 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
d323c6b6 377 gettextln "Unable to determine absolute path of git directory" >&2
10587ce6
JH
378 exit 1
379 }
01247e02 380 : "${GIT_OBJECT_DIRECTORY="$(git rev-parse --git-path objects)"}"
1c7e2d23
DA
381}
382
383if test -z "$NONGIT_OK"
384then
385 git_dir_init
10587ce6 386fi
bac1ddd0
RR
387
388peel_committish () {
389 case "$1" in
390 :/*)
391 peeltmp=$(git rev-parse --verify "$1") &&
392 git rev-parse --verify "${peeltmp}^0"
393 ;;
394 *)
395 git rev-parse --verify "${1}^0"
396 ;;
397 esac
398}